=== crengine/Tools/CMakeLists.txt ===

if(UNIX)
	add_subdirectory(Fb2Linux)
endif(UNIX)

add_subdirectory(GammaGen)
add_subdirectory(HyphConv)
add_subdirectory(langstat)
add_subdirectory(langstat2)
