=== debian/changelog ===
coolreader3 (3.2.32-1mx21+1) mx; urgency=medium

  * Rebuild for MX 21.
  * Build Qt 5 version.
  * Bump to debhelper compat 10.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 01 Nov 2021 15:16:50 -0700

coolreader3 (3.2.32-1mx19+1) mx; urgency=medium

  * New upstream version, rebuild for MX 19.
  * Add libharfbuzz-dev to B-Ds.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 22 Oct 2019 16:31:18 -0700
