=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=4

override_dh_auto_configure:
	dh_auto_configure -- \
		-D GUI=QT5 \
		-D CMAKE_BUILD_TYPE=Release \
		-D CMAKE_INSTALL_PREFIX=/usr \
		-D DOC_DATA_COMPRESSION_LEVEL=3 \
		-D DOC_BUFFER_SIZE=0x2500000 \
		-D MAX_IMAGE_SCALE_MUL=2 \
		-D USE_UNRAR=1

%:
	dh  $@

# MX don't need no stinkin' dbgsyms
override_dh_strip:
	dh_strip --no-automatic-dbgsym
